
#include <stdio.h>
#include <string.h>
#include <iomanip.h>
#include <iostream.h>
#include <fstream.h>

class TableProducer {
   public :
      TableProducer(char*);
      char * read(int,char*);
      char * returnStat();
   private:
      int debug;
      unsigned item;
      float EbestTot, EworstTot, EaveTot;
      float BbestTot, BworstTot, BaveTot;
}; // end of TableProducer

TableProducer::TableProducer(char *_fName)
{  item=BbestTot=BworstTot=BaveTot=debug=0;
   EbestTot=EworstTot=EaveTot=0;}

char * TableProducer::returnStat()
{  char * ret = new char[100];
   if(item>0)
   sprintf(ret," & %10.2f & %10.2f & %10.2f & & & & & %10.2f & %10.2f & %10.2f &  & & & & \\\\ \\hline ",
		 BbestTot/item,BaveTot/item,BworstTot/item,EbestTot/item,EaveTot/item,EworstTot/item );
   else   sprintf(ret," & 0 & 0 & 0 & & & & & 0 & 0 & 0 & & & & &  \\\\ \\hline ");

   return ret;

}// end of returnStat()

char * TableProducer::read(int Test,char *fileName)
{  char * ret = NULL;

   ifstream infile(fileName);

   if(debug)
   { cout << " File Name is : " << fileName ;
     cout << (infile==NULL?" does not exist":" exisst") << endl;
   }

   if(infile )
   {  ret = new char[200];
      int  Bbest, best, number;  
      int  Baverage, average;  
      int  Bworst, worst;  
      float  BPc, Pc;  
      float  BPm, Pm;  
      int  BNM, NM;  
      float  BSum, Sum;  

      infile >> number;
      infile >> best;
      infile >> worst;
      infile >> average;
      infile >> Pc;
      infile >> Pm;
      infile >> NM;
      infile >> Sum;
      //infile.ignore('\n');

      Bbest = best; Baverage = average; Bworst = worst;
      BPc = Pc; BPm = Pm; BNM = NM; BSum = Sum; 

      while( !infile.eof() )
      {

	 if(debug)
	 {  cout << number << " " << best << " ";
            cout << average << " "<< worst << " "<< Pc << " ";
            cout << Pm << " " << NM << " " << Sum << endl;
	 }

      infile >> number;
      infile >> best;
      infile >> worst;
      infile >> average;
      infile >> Pc;
      infile >> Pm;
      infile >> NM;
      infile >> Sum;
      //infile.ignore('\n');

      }// end of while

      sprintf(ret," %d & %d & %d & %d & %6.4f & %6.4f & %d & %6.4f & %d & %d & %d &  %6.4f & %6.4f & %d & %6.4f & \\\\ \\hline ",
		 Test, Bbest,Baverage,Bworst,BPc,BPm, BNM, BSum,
		 best,average,worst, Pc, Pm, NM, Sum );
 
      BbestTot+=Bbest; BworstTot+=Bworst; BaveTot+=Baverage;
      EbestTot+=best;  EworstTot+=worst;  EaveTot+=average;
      item++;

      infile.close();

   }// end of if

   return ret;

}// end of read()


main()
{  char fileName[30];
   char *ret;
   TableProducer A(fileName);

   for(unsigned i=0;i<10;i++)
   {  sprintf(fileName,"GAStatisticsT%d.out",i+1);
      ret = A.read(i+1,fileName);
      if(ret) cout << ret << endl;
   }// end of for 

   cout << A.returnStat() << endl;

}// end of main
